/*!
 * Copyright (c) 2010 aizo ag, Switzerland
 *
 * \author Johannes Winkelmann, johannes.winkelmann@aizo.com
 */

#ifndef FIRMWAREFILE_H_
#define FIRMWAREFILE_H_

#include <string>
#include <inttypes.h>

#include "firmwareimageinfo.h"

class ErrorMessage;

/*!
 * \class FirmwareFile
 * \brief Representation of a firmware image file
 */
class FirmwareFile
{
public:

  FirmwareFile(ErrorMessage& errorMessage);
  bool open(const std::string& fileName);

  int readChunk(uint8_t* buffer, unsigned int count);
  void close();
  
  bool setPosition(unsigned int pos);

  const FirmwareImageInfo& imageInfo() const;

  static std::string deviceIdToString(DeviceId_t);

private:
  void init();
  bool parseHeader();

  bool m_opened;
  int m_fd;
  FirmwareImageInfo m_imageInfo;
  uint32_t m_fileSize;
  ErrorMessage& m_errorMessage;
};

#endif /* FIRMWAREFILE_H_ */
