#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

#include "gettext_helper.h"

namespace gtutil
{

// Replacing the gnu autosprintf() with an own implementation is borrowed
// from the systemtap project: http://sourceware.org/systemtap/

std::string autosprintf(const char* format, ...)
{
  va_list args;
  char *str;
  va_start(args, format);
  int rc = vasprintf(&str, format, args);
  if (rc < 0) {
    va_end(args);
    return gettext("autosprintf/vasprintf error");
  }
  std::string s = str;
  va_end(args);
  free(str);
  return s; /* by copy */
}

}
