/*!
 * Copyright (c) 2010, 2011 aizo ag, Switzerland
 *
 * \author Johannes Winkelmann, johannes.winkelmann@aizo.com
 * \author Sergey Bostandzhyan, jin@dev.digitalstrom.org
 */

#include <libintl.h>
#include <stdio.h>
#include <stdlib.h>

#include "firmwareupgrade.h"

int main(int argc, char** argv)
{
  char *gt_locale = NULL;
  char *gt_binding = NULL;
  char *gt_domain = NULL;

  FirmwareUpgrade fw;

  gt_locale = setlocale(LC_ALL, "");
  if (gt_locale == NULL) {
    fprintf(stderr, "Could not retrieve system locale settings!\n");
  } else {
    printf("Using locale %s\n", gt_locale);
  }

  gt_binding = bindtextdomain("dsf-firmware-upgrade", getenv("TEXTDOMAINDIR"));
  if (gt_binding == NULL) {
    fprintf(stderr, "Could not bind text domain! Messages will not be"
        "translated.\n");
  } else {
    printf("Using locales from %s\n", gt_binding);
  }

  gt_domain = textdomain("dsf-firmware-upgrade");
  if (gt_domain == NULL) {
    fprintf(stderr, "Could not setup text domain! Messages will not be"
        " translated.\n");
  } else {
    printf("Using text domain %s\n", gt_domain);
  }

  return fw.run(argc, argv);
}
